#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include "benchmark.h"

int main(int argc, char **argv) {
	struct timeb start;
	struct timeb end;
	Triangle triangle;
	triangle.type=0;
	Vertex3D vertex;
	Vertex3D *startV=&vertex;
	Vertex3D *direction=&vertex;
	GeometryObject *object = (GeometryObject *)&triangle;
	int i,j;
	
	fprintf(stdout, "Size of triangle: %d\n", sizeof(Triangle));
	ftime(&start);
	for(j=0; j<10000; j++) {
		for(i=0; i<10000; i++) {
			switch(object->type) {
			case 0:
				intersectTriangle((Triangle *)object, 
					startV, direction);
				break;
			default:
				//Error...
				break;
			}
		}
	}
	ftime(&end);
	double time = end.time-start.time;
	time *= 1000;
	time += end.millitm-start.millitm;
	time /= 1000;
	fprintf(stdout, "Intersect Method Calls: %lf\n", time);
}
