#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include "benchmark.h"

int main(int argc, char **argv) {
	struct timeb start;
	struct timeb end;
	
	fprintf(stdout, "Size of triangle: %d\n", 
		sizeof(Triangle));
	Triangle *triangle = new Triangle();
	GeometryObject *object = triangle;
	Ray *ray = new Ray();
	ftime(&start);
	for(int j=0; j<10000; j++) {
		for(long i=0; i<10000; i++) {
			object->intersect(ray);
		}
	}
	ftime(&end);
	double time = end.time-start.time;
	time *= 1000;
	time += end.millitm-start.millitm;
	time /= 1000;
	fprintf(stdout, "Virtual Method Calls: %lf\n", time);
}
